Metacat - Bug #248

id finder needed for metacat
07/10/2001 04:40 PM - Chad Berkley
Description

Metacat needs a utility function so that morpho can query it and find the last
id used by a specific user. right now, if a user goes to another computer, his
id sequence is reset, causing id conflicts when the documents are uploaded.
the <profile>.xml file in morpho needs to be able to be updated with the latest
id that was used in metacat. this should be done dynamically when morpho
starts up. | will also enter a bug for morpho for this.

Related issues:
Blocked by Morpho - Bug #254: Look up id sequence on morpho startup
Blocked by Morpho - Bug #301: use UID as scope, chek for conflicts

Resolved 07/12/2001
Resolved 10/16/2001

History

#1 - 07/16/2001 01:27 PM - Jivka Bojilova

DONE

Included utility function about gettig the latest docid for a user:
DBUtil.getLastDocid(username).

Required Metacat' parameters:

- action="getlastdocid’

- username

The SQL Statement used:

SELECT docid, rev, date_updated
FROM xml_documents

WHERE user_owner = @username
AND date_updated = (SELECT MAX
FROM xml_documents

WHERE user_owner = @username)
UNION

SELECT docid, rev, date_updated
FROM xml_revisions

WHERE user_owner = @username
AND date_updated = (SELECT MAX
FROM xml_revisions

WHERE user_owner = @username)
ORDER BY date_updated

#2 - 07/16/2001 01:30 PM - Jivka Bojilova
DONE

#3 - 10/15/2001 04:40 PM - Dan Higgins

It appears that Metacat does NOT return the LAST ID (It seems to return the last
id of a dataset document. But there are other documents in a dataset which have
larger ids.) Morpho adds 5 to the numbe returned, but this is not always a good fix.

#4 - 10/16/2001 08:12 PM - Matt Jones
Need to change this function so that metacat returns the largest id number used

for a particular scope, regardless of which user owns the documents. Thus, we
may need to rename the function to "getMaxIdForScope" or something similar.

#5 - 10/18/2001 05:37 PM - Dan Higgins
The current version of this code in Metacat will work correctly with the current

version of Morpho. The problem was related to accession numbers being assigned

in Morpho in a different order than documents were inserted into Metacat. (The

Metacat code checks insertion times rather than accession numbers.)

Morpho has been changed to insert documents in the same order that accession
numbere are assigned. Also, the next accession id stord in the profile is now
updated when Morpho starts up.

#6 - 10/19/2001 04:48 PM - Matt Jones

Rewrote the SQL function to select the MAX accession number used for a given

scope. The scope is now passed into Metacat using a "scope" parameter. Renamed
functions to properly reflect that they are selecting the MAX id rather than the
last id. The new SQL algorithm looks like this:
#7 - 10/19/2001 04:50 PM - Matt Jones

FIXED with previosuly committed changes.

#8 - 10/19/2001 04:56 PM - Matt Jones
Resolved/FIXED.

#9 - 03/27/2013 02:13 PM - Redmine Admin

Original Bugzilla ID was 248
